<?php
if ( ! class_exists( 'Renewable_Energy_Lite_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Renewable_Energy_Lite_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Renewable_Energy_Lite_Plugin_Activation_WPElemento_Importer {

        private static $renewable_energy_lite_instance;
        public $renewable_energy_lite_action_count;
        public $renewable_energy_lite_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$renewable_energy_lite_instance) ) {
            self::$renewable_energy_lite_instance = new self();
          }
          return self::$renewable_energy_lite_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'renewable_energy_lite_recommended_plugins', array($this, 'renewable_energy_lite_recommended_elemento_importer_plugins_array') );

            $renewable_energy_lite_actions                   = $this->renewable_energy_lite_get_recommended_actions();
            $this->renewable_energy_lite_action_count        = $renewable_energy_lite_actions['count'];
            $this->renewable_energy_lite_recommended_actions = $renewable_energy_lite_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function renewable_energy_lite_recommended_elemento_importer_plugins_array($renewable_energy_lite_plugins){
            $renewable_energy_lite_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'renewable-energy-lite'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'renewable-energy-lite'),               
            );
            return $renewable_energy_lite_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'renewable-energy-lite-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('renewable-energy-lite-plugin-activation-script', 'renewable_energy_lite_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'renewable-energy-lite'),
                    'activating' => esc_html__('Activating', 'renewable-energy-lite'),
                    'error' => esc_html__('Error', 'renewable-energy-lite'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'renewable-energy-lite-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function renewable_energy_lite_get_recommended_actions() {

            $renewable_energy_lite_act_count  = 0;
            $renewable_energy_lite_actions_todo = get_option( 'recommending_actions', array());

            $renewable_energy_lite_plugins = $this->renewable_energy_lite_get_recommended_plugins();

            if ($renewable_energy_lite_plugins) {
                foreach ($renewable_energy_lite_plugins as $renewable_energy_lite_key => $renewable_energy_lite_plugin) {
                    $renewable_energy_lite_action = array();
                    if (!isset($renewable_energy_lite_plugin['slug'])) {
                        continue;
                    }

                    $renewable_energy_lite_action['id']   = 'install_' . $renewable_energy_lite_plugin['slug'];
                    $renewable_energy_lite_action['desc'] = '';
                    if (isset($renewable_energy_lite_plugin['desc'])) {
                        $renewable_energy_lite_action['desc'] = $renewable_energy_lite_plugin['desc'];
                    }

                    $renewable_energy_lite_action['name'] = '';
                    if (isset($renewable_energy_lite_plugin['name'])) {
                        $renewable_energy_lite_action['title'] = $renewable_energy_lite_plugin['name'];
                    }

                    $renewable_energy_lite_link_and_is_done  = $this->renewable_energy_lite_get_plugin_buttion($renewable_energy_lite_plugin['slug'], $renewable_energy_lite_plugin['name'], $renewable_energy_lite_plugin['function']);
                    $renewable_energy_lite_action['link']    = $renewable_energy_lite_link_and_is_done['button'];
                    $renewable_energy_lite_action['is_done'] = $renewable_energy_lite_link_and_is_done['done'];
                    if (!$renewable_energy_lite_action['is_done'] && (!isset($renewable_energy_lite_actions_todo[$renewable_energy_lite_action['id']]) || !$renewable_energy_lite_actions_todo[$renewable_energy_lite_action['id']])) {
                        $renewable_energy_lite_act_count++;
                    }
                    $renewable_energy_lite_recommended_actions[] = $renewable_energy_lite_action;
                    $renewable_energy_lite_actions_todo[]        = array('id' => $renewable_energy_lite_action['id'], 'watch' => true);
                }
                return array('count' => $renewable_energy_lite_act_count, 'actions' => $renewable_energy_lite_recommended_actions);
            }

        }

        public function renewable_energy_lite_get_recommended_plugins() {

            $renewable_energy_lite_plugins = apply_filters('renewable_energy_lite_recommended_plugins', array());
            return $renewable_energy_lite_plugins;
        }

        public function renewable_energy_lite_get_plugin_buttion($slug, $name, $function) {
                $renewable_energy_lite_is_done      = false;
                $renewable_energy_lite_button_html  = '';
                $renewable_energy_lite_is_installed = $this->is_plugin_installed($slug);
                $renewable_energy_lite_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $renewable_energy_lite_is_activeted = (class_exists($function)) ? true : false;
                if (!$renewable_energy_lite_is_installed) {
                    $renewable_energy_lite_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $renewable_energy_lite_plugin_install_url = wp_nonce_url($renewable_energy_lite_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $renewable_energy_lite_button_html        = sprintf('<a class="renewable-energy-lite-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($renewable_energy_lite_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'renewable-energy-lite'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'renewable-energy-lite')
                    );
                } elseif ($renewable_energy_lite_is_installed && !$renewable_energy_lite_is_activeted) {

                    $renewable_energy_lite_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($renewable_energy_lite_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $renewable_energy_lite_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $renewable_energy_lite_button_html = sprintf('<a class="renewable-energy-lite-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($renewable_energy_lite_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'renewable-energy-lite'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'renewable-energy-lite')
                    );
                } elseif ($renewable_energy_lite_is_activeted) {
                    $renewable_energy_lite_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'renewable-energy-lite'));
                    $renewable_energy_lite_is_done     = true;
                }

                return array('done' => $renewable_energy_lite_is_done, 'button' => $renewable_energy_lite_button_html);
            }
        public function is_plugin_installed($slug) {
            $renewable_energy_lite_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $renewable_energy_lite_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($renewable_energy_lite_installed_plugins[$renewable_energy_lite_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $renewable_energy_lite_keys = array_keys($this->get_installed_plugins());
            foreach ($renewable_energy_lite_keys as $renewable_energy_lite_key) {
                if (preg_match('|^' . $slug . '/|', $renewable_energy_lite_key)) {
                    return $renewable_energy_lite_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Renewable_Energy_Lite_Plugin_Activation_WPElemento_Importer::get_instance();